Package org.gradle.api

## Interface NamedDomainObjectList<T>

- Type Parameters:
    `T` - The type of objects in the list
  All Superinterfaces:
    `java.util.Collection<T>`, `DomainObjectCollection<T>`, `java.lang.Iterable<T>`, `java.util.List<T>`, `NamedDomainObjectCollection<T>`
  All Known Subinterfaces:
    `ArtifactRepositoryContainer`, `RepositoryHandler`

      public interface NamedDomainObjectList<T>
      extends NamedDomainObjectCollection<T>, java.util.List<T>

  A specialization of `NamedDomainObjectCollection` that also implements `List`.

  All object equality is determined in terms of object names. That is, calling `remove()` with an object that is NOT equal to an existing object in terms of `equals`, but IS in terms of name equality will result in the existing collection item with the equal name being removed.

  You can create an instance of this type using the factory method `ObjectFactory.namedDomainObjectList(Class)`.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.List<T>` | `findAll​(Closure spec)` | Returns a collection which contains the objects in this collection which meet the given closure specification.
    `NamedDomainObjectList<T>` | `matching​(Closure spec)` | Returns a collection which contains the objects in this collection which meet the given closure specification.
    `NamedDomainObjectList<T>` | `matching​(Spec<? super T> spec)` | Returns a collection which contains the objects in this collection which meet the given specification.
    `NamedDomainObjectList<T>` | `named​(Spec<java.lang.String> nameFilter)` | Returns a collection containing the objects with names matching the provided filter.
    `<S extends T> NamedDomainObjectList<S>` | `withType​(java.lang.Class<S> type)` | Returns a collection containing the objects in this collection of the given type.

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream, toArray`

    - ### Methods inherited from interface org.gradle.api.DomainObjectCollection

      `addAllLater, addLater, all, all, configureEach, whenObjectAdded, whenObjectAdded, whenObjectRemoved, whenObjectRemoved, withType, withType`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface java.util.List

      `add, add, addAll, addAll, clear, contains, containsAll, equals, get, hashCode, indexOf, isEmpty, iterator, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, replaceAll, retainAll, set, size, sort, spliterator, subList, toArray, toArray`

    - ### Methods inherited from interface org.gradle.api.NamedDomainObjectCollection

      `add, addAll, addRule, addRule, addRule, findByName, getAsMap, getAt, getByName, getByName, getByName, getCollectionSchema, getNamer, getNames, getRules, named, named, named, named`

- - ### Method Detail

    - #### withType

          <S extends T> NamedDomainObjectList<S> withType​(java.lang.Class<S> type)

      Returns a collection containing the objects in this collection of the given type. The returned collection is live, so that when matching objects are later added to this collection, they are also visible in the filtered collection.
      Specified by:
        `withType` in interface `DomainObjectCollection<T>`
      Specified by:
        `withType` in interface `NamedDomainObjectCollection<T>`
      Parameters:
        `type` - The type of objects to find.
      Returns:
        The matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### named

          NamedDomainObjectList<T> named​(Spec<java.lang.String> nameFilter)

      Returns a collection containing the objects with names matching the provided filter. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection. This method will NOT cause any pending objects in this container to be realized.
      Specified by:
        `named` in interface `NamedDomainObjectCollection<T>`
      Parameters:
        `nameFilter` - The specification to test names against.
      Returns:
        The collection of objects with names satisfying the filter. Returns an empty collection if there are no such objects in this collection.

    - #### matching

          NamedDomainObjectList<T> matching​(Spec<? super T> spec)

      Returns a collection which contains the objects in this collection which meet the given specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T>`
      Specified by:
        `matching` in interface `NamedDomainObjectCollection<T>`
      Parameters:
        `spec` - The specification to use.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### matching

          NamedDomainObjectList<T> matching​(Closure spec)

      Returns a collection which contains the objects in this collection which meet the given closure specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T>`
      Specified by:
        `matching` in interface `NamedDomainObjectCollection<T>`
      Parameters:
        `spec` - The specification to use. The closure gets a collection element as an argument.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### findAll

          java.util.List<T> findAll​(Closure spec)

      Returns a collection which contains the objects in this collection which meet the given closure specification.
      Specified by:
        `findAll` in interface `DomainObjectCollection<T>`
      Parameters:
        `spec` - The specification to use. The closure gets a collection element as an argument.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.